diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 9d22950d79b..14737295831 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -5845,8 +4793,8 @@ exploded_graph::dump_exploded_nodes () const
     }
 
   /* Emit a warning at any call to "__analyzer_dump_exploded_nodes",
-     giving the number of processed exploded nodes for "before-stmt",
-     and the IDs of processed, merger, and worklist enodes.
+     giving the number of processed exploded nodes at the snode before
+     the call, and the IDs of processed, merger, and worklist enodes.
 
      We highlight the count of *processed* enodes since this is of most
      interest in DejaGnu tests for ensuring that state merger has
@@ -5861,89 +4809,94 @@ exploded_graph::dump_exploded_nodes () const
   hash_set<const gimple *> seen;
   FOR_EACH_VEC_ELT (m_nodes, i, enode)
     {
-      if (enode->get_point ().get_kind () != PK_BEFORE_STMT)
+      const supernode *snode = enode->get_supernode ();
+      if (!snode)
+	continue;
+      if (snode->m_succs.length () != 1)
+	continue;
+      const superedge *sedge = snode->m_succs[0];
+      if (!sedge->get_op ())
+	continue;
+      const call_and_return_op *op
+	= sedge->get_op ()->dyn_cast_call_and_return_op ();
+      if (!op)
 	continue;
+      const gcall &call = op->get_gcall ();
+      if (is_special_named_call_p (call, "__analyzer_dump_exploded_nodes", 1))
+	{
+	  if (seen.contains (&call))
+	    continue;
 
-      if (const gimple *stmt = enode->get_stmt ())
-	if (const gcall *call = dyn_cast <const gcall *> (stmt))
-	  if (is_special_named_call_p (*call, "__analyzer_dump_exploded_nodes",
-				       1))
+	  auto_vec<exploded_node *> processed_enodes;
+	  auto_vec<exploded_node *> merger_enodes;
+	  auto_vec<exploded_node *> worklist_enodes;
+	  /* This is O(N^2).  */
+	  unsigned j;
+	  exploded_node *other_enode;
+	  FOR_EACH_VEC_ELT (m_nodes, j, other_enode)
 	    {
-	      if (seen.contains (stmt))
-		continue;
-
-	      auto_vec<exploded_node *> processed_enodes;
-	      auto_vec<exploded_node *> merger_enodes;
-	      auto_vec<exploded_node *> worklist_enodes;
-	      /* This is O(N^2).  */
-	      unsigned j;
-	      exploded_node *other_enode;
-	      FOR_EACH_VEC_ELT (m_nodes, j, other_enode)
-		{
-		  if (other_enode->get_point ().get_kind () != PK_BEFORE_STMT)
-		    continue;
-		  if (other_enode->get_stmt () == stmt)
-		    switch (other_enode->get_status ())
-		      {
-		      default:
-			gcc_unreachable ();
-		      case exploded_node::status::worklist:
-			worklist_enodes.safe_push (other_enode);
-			break;
-		      case exploded_node::status::processed:
-			processed_enodes.safe_push (other_enode);
-			break;
-		      case exploded_node::status::merger:
-			merger_enodes.safe_push (other_enode);
-			break;
-		      }
-		}
+	      if (other_enode->get_supernode () == snode)
+		switch (other_enode->get_status ())
+		  {
+		  default:
+		    gcc_unreachable ();
+		  case exploded_node::status::worklist:
+		    worklist_enodes.safe_push (other_enode);
+		    break;
+		  case exploded_node::status::processed:
+		    processed_enodes.safe_push (other_enode);
+		    break;
+		  case exploded_node::status::merger:
+		    merger_enodes.safe_push (other_enode);
+		    break;
+		  }
+	    }
 
-	      pretty_printer pp;
-	      pp_character (&pp, '[');
-	      print_enode_indices (&pp, processed_enodes);
-	      if (merger_enodes.length () > 0)
-		{
-		  pp_string (&pp, "] merger(s): [");
-		  print_enode_indices (&pp, merger_enodes);
-		}
-	      if (worklist_enodes.length () > 0)
-		{
-		  pp_string (&pp, "] worklist: [");
-		  print_enode_indices (&pp, worklist_enodes);
-		}
-	      pp_character (&pp, ']');
-
-	      warning_n (stmt->location, 0, processed_enodes.length (),
-			 "%i processed enode: %s",
-			 "%i processed enodes: %s",
-			 processed_enodes.length (), pp_formatted_text (&pp));
-	      seen.add (stmt);
-
-	      /* If the argument is non-zero, then print all of the states
-		 of the various enodes.  */
-	      tree t_arg = fold (gimple_call_arg (call, 0));
-	      if (TREE_CODE (t_arg) != INTEGER_CST)
-		{
-		  error_at (call->location,
-			    "integer constant required for arg 1");
-		  return;
-		}
-	      int i_arg = TREE_INT_CST_LOW (t_arg);
-	      if (i_arg)
+	  pretty_printer pp;
+	  pp_character (&pp, '[');
+	  print_enode_indices (&pp, processed_enodes);
+	  if (merger_enodes.length () > 0)
+	    {
+	      pp_string (&pp, "] merger(s): [");
+	      print_enode_indices (&pp, merger_enodes);
+	    }
+	  if (worklist_enodes.length () > 0)
+	    {
+	      pp_string (&pp, "] worklist: [");
+	      print_enode_indices (&pp, worklist_enodes);
+	    }
+	  pp_character (&pp, ']');
+
+	  warning_n (call.location, 0, processed_enodes.length (),
+		     "%i processed enode: %s",
+		     "%i processed enodes: %s",
+		     processed_enodes.length (), pp_formatted_text (&pp));
+	  seen.add (&call);
+
+	  /* If the argument is non-zero, then print all of the states
+	     of the various enodes.  */
+	  tree t_arg = fold (gimple_call_arg (&call, 0));
+	  if (TREE_CODE (t_arg) != INTEGER_CST)
+	    {
+	      error_at (snode->m_loc,
+			"integer constant required for arg 1");
+	      return;
+	    }
+	  int i_arg = TREE_INT_CST_LOW (t_arg);
+	  if (i_arg)
+	    {
+	      exploded_node *other_enode;
+	      FOR_EACH_VEC_ELT (processed_enodes, j, other_enode)
 		{
-		  exploded_node *other_enode;
-		  FOR_EACH_VEC_ELT (processed_enodes, j, other_enode)
-		    {
-		      fprintf (stderr, "%i of %i: EN %i:\n",
-			       j + 1, processed_enodes.length (),
-			       other_enode->m_index);
-		      other_enode->dump_succs_and_preds (stderr);
-		      /* Dump state.  */
-		      other_enode->get_state ().dump (m_ext_state, false);
-		    }
+		  fprintf (stderr, "%i of %i: EN %i:\n",
+			   j + 1, processed_enodes.length (),
+			   other_enode->m_index);
+		  other_enode->dump_succs_and_preds (stderr);
+		  /* Dump state.  */
+		  other_enode->get_state ().dump (m_ext_state, false);
 		}
 	    }
+	}
     }
 }
 
@@ -5985,261 +4938,11 @@ exploded_graph::on_escaped_function (tree fndecl)
     }
 }
 
-/* A collection of classes for visualizing the callgraph in .dot form
-   (as represented in the supergraph).  */
-
-/* Forward decls.  */
-class viz_callgraph_node;
-class viz_callgraph_edge;
-class viz_callgraph;
-class viz_callgraph_cluster;
-
-/* Traits for using "digraph.h" to visualize the callgraph.  */
-
-struct viz_callgraph_traits
-{
-  typedef viz_callgraph_node node_t;
-  typedef viz_callgraph_edge edge_t;
-  typedef viz_callgraph graph_t;
-  struct dump_args_t
-  {
-    dump_args_t (const exploded_graph *eg) : m_eg (eg) {}
-    const exploded_graph *m_eg;
-  };
-  typedef viz_callgraph_cluster cluster_t;
-};
-
-/* Subclass of dnode representing a function within the callgraph.  */
-
-class viz_callgraph_node : public dnode<viz_callgraph_traits>
-{
-  friend class viz_callgraph;
-
-public:
-  viz_callgraph_node (function *fun, int index)
-  : m_fun (fun), m_index (index), m_num_supernodes (0), m_num_superedges (0)
-  {
-    gcc_assert (fun);
-  }
-
-  void dump_dot (graphviz_out *gv, const dump_args_t &args) const final override
-  {
-    pretty_printer *pp = gv->get_pp ();
-
-    dump_dot_id (pp);
-    pp_printf (pp, " [shape=none,margin=0,style=filled,fillcolor=%s,label=\"",
-	       "lightgrey");
-    pp_write_text_to_stream (pp);
-
-    pp_printf (pp, "VCG: %i: %s", m_index, function_name (m_fun));
-    pp_newline (pp);
-
-    pp_printf (pp, "supernodes: %i\n", m_num_supernodes);
-    pp_newline (pp);
-
-    pp_printf (pp, "superedges: %i\n", m_num_superedges);
-    pp_newline (pp);
-
-    if (args.m_eg)
-      {
-	unsigned i;
-	exploded_node *enode;
-	unsigned num_enodes = 0;
-	FOR_EACH_VEC_ELT (args.m_eg->m_nodes, i, enode)
-	  {
-	    if (enode->get_point ().get_function () == m_fun)
-	      num_enodes++;
-	  }
-	pp_printf (pp, "enodes: %i\n", num_enodes);
-	pp_newline (pp);
-
-	// TODO: also show the per-callstring breakdown
-	const exploded_graph::call_string_data_map_t *per_cs_data
-	  = args.m_eg->get_per_call_string_data ();
-	for (exploded_graph::call_string_data_map_t::iterator iter
-	       = per_cs_data->begin ();
-	     iter != per_cs_data->end ();
-	     ++iter)
-	  {
-	    const call_string *cs = (*iter).first;
-	    //per_call_string_data *data = (*iter).second;
-	    num_enodes = 0;
-	    FOR_EACH_VEC_ELT (args.m_eg->m_nodes, i, enode)
-	      {
-		if (enode->get_point ().get_function () == m_fun
-		    && &enode->get_point ().get_call_string () == cs)
-		  num_enodes++;
-	      }
-	    if (num_enodes > 0)
-	      {
-		cs->print (pp);
-		pp_printf (pp, ": %i\n", num_enodes);
-	      }
-	  }
-
-	/* Show any summaries.  */
-	per_function_data *data = args.m_eg->get_per_function_data (m_fun);
-	if (data)
-	  {
-	    pp_newline (pp);
-	    pp_printf (pp, "summaries: %i\n", data->m_summaries.length ());
-	    for (auto summary : data->m_summaries)
-	      {
-		pp_printf (pp, "\nsummary: %s:\n", summary->get_desc ().get ());
-		const extrinsic_state &ext_state = args.m_eg->get_ext_state ();
-		const program_state &state = summary->get_state ();
-		state.dump_to_pp (ext_state, false, true, pp);
-		pp_newline (pp);
-	      }
-	  }
-      }
-
-    pp_write_text_as_dot_label_to_stream (pp, /*for_record=*/true);
-    pp_string (pp, "\"];\n\n");
-    pp_flush (pp);
-  }
-
-  void dump_dot_id (pretty_printer *pp) const
-  {
-    pp_printf (pp, "vcg_%i", m_index);
-  }
-
-private:
-  function *m_fun;
-  int m_index;
-  int m_num_supernodes;
-  int m_num_superedges;
-};
-
-/* Subclass of dedge representing a callgraph edge.  */
-
-class viz_callgraph_edge : public dedge<viz_callgraph_traits>
-{
-public:
-  viz_callgraph_edge (viz_callgraph_node *src, viz_callgraph_node *dest)
-  : dedge<viz_callgraph_traits> (src, dest)
-  {}
-
-  void dump_dot (graphviz_out *gv, const dump_args_t &) const
-    final override
-  {
-    pretty_printer *pp = gv->get_pp ();
-
-    const char *style = "\"solid,bold\"";
-    const char *color = "black";
-    int weight = 10;
-    const char *constraint = "true";
-
-    m_src->dump_dot_id (pp);
-    pp_string (pp, " -> ");
-    m_dest->dump_dot_id (pp);
-    pp_printf (pp,
-	       (" [style=%s, color=%s, weight=%d, constraint=%s,"
-		" headlabel=\""),
-	       style, color, weight, constraint);
-    pp_printf (pp, "\"];\n");
-  }
-};
-
-/* Subclass of digraph representing the callgraph.  */
-
-class viz_callgraph : public digraph<viz_callgraph_traits>
-{
-public:
-  viz_callgraph (const supergraph &sg);
-
-  viz_callgraph_node *get_vcg_node_for_function (function *fun)
-  {
-    return *m_map.get (fun);
-  }
-
-  viz_callgraph_node *get_vcg_node_for_snode (supernode *snode)
-  {
-    return get_vcg_node_for_function (snode->m_fun);
-  }
-
-private:
-  hash_map<function *, viz_callgraph_node *> m_map;
-};
-
-/* Placeholder subclass of cluster.  */
-
-class viz_callgraph_cluster : public cluster<viz_callgraph_traits>
-{
-};
-
-/* viz_callgraph's ctor.  */
-
-viz_callgraph::viz_callgraph (const supergraph &sg)
-{
-  cgraph_node *node;
-  FOR_EACH_FUNCTION_WITH_GIMPLE_BODY (node)
-    {
-      function *fun = node->get_fun ();
-      viz_callgraph_node *vcg_node
-	= new viz_callgraph_node (fun, m_nodes.length ());
-      m_map.put (fun, vcg_node);
-      add_node (vcg_node);
-    }
-
-  unsigned i;
-  superedge *sedge;
-  FOR_EACH_VEC_ELT (sg.m_edges, i, sedge)
-    {
-      viz_callgraph_node *vcg_src = get_vcg_node_for_snode (sedge->m_src);
-      if (vcg_src->m_fun)
-	get_vcg_node_for_function (vcg_src->m_fun)->m_num_superedges++;
-      if (sedge->dyn_cast_call_superedge ())
-	{
-	  viz_callgraph_node *vcg_dest = get_vcg_node_for_snode (sedge->m_dest);
-	  viz_callgraph_edge *vcg_edge
-	    = new viz_callgraph_edge (vcg_src, vcg_dest);
-	  add_edge (vcg_edge);
-	}
-    }
-
-  supernode *snode;
-  FOR_EACH_VEC_ELT (sg.m_nodes, i, snode)
-    {
-      if (snode->m_fun)
-	get_vcg_node_for_function (snode->m_fun)->m_num_supernodes++;
-    }
-}
-
-/* Dump the callgraph to FILENAME.  */
-
-static void
-dump_callgraph (const supergraph &sg, const char *filename,
-		const exploded_graph *eg)
-{
-  FILE *outf = fopen (filename, "w");
-  if (!outf)
-    return;
-
-  // TODO
-  viz_callgraph vcg (sg);
-  vcg.dump_dot (filename, nullptr, viz_callgraph_traits::dump_args_t (eg));
-
-  fclose (outf);
-}
-
-/* Dump the callgraph to "<srcfile>.callgraph.dot".  */
-
-static void
-dump_callgraph (const supergraph &sg, const exploded_graph *eg)
-{
-  auto_timevar tv (TV_ANALYZER_DUMP);
-  char *filename = concat (dump_base_name, ".callgraph.dot", nullptr);
-  dump_callgraph (sg, filename, eg);
-  free (filename);
-}
-
 /* Subclass of dot_annotator for implementing
-   DUMP_BASE_NAME.supergraph-eg.dot, a post-analysis dump of the supergraph.
+   DUMP_BASE_NAME.supergraph.N.eg.dot, a post-analysis dump of the supergraph.
 
    Annotate the supergraph nodes by printing the exploded nodes in concise
-   form within them, next to their pertinent statements where appropriate,
-   colorizing the exploded nodes based on sm-state.
+   form within them, colorizing the exploded nodes based on sm-state.
    Also show saved diagnostics within the exploded nodes, giving information
    on whether they were feasible, and, if infeasible, where the problem
    was.  */
@@ -6250,110 +4953,89 @@ public:
   exploded_graph_annotator (const exploded_graph &eg)
   : m_eg (eg)
   {
-    /* Avoid O(N^2) by prepopulating m_enodes_per_snodes.  */
-    unsigned i;
-    supernode *snode;
-    FOR_EACH_VEC_ELT (eg.get_supergraph ().m_nodes, i, snode)
-      m_enodes_per_snodes.safe_push (new auto_vec <exploded_node *> ());
+    /* Avoid O(N^2) by prepopulating m_enodes_per_snode_id.  */
+    for (int i = 0; i < eg.get_supergraph ().m_nodes.length (); ++i)
+      m_enodes_per_snode_id.push_back (std::vector<exploded_node *> ());
     exploded_node *enode;
+    unsigned i;
     FOR_EACH_VEC_ELT (m_eg.m_nodes, i, enode)
       if (enode->get_supernode ())
-	m_enodes_per_snodes[enode->get_supernode ()->m_index]->safe_push (enode);
+	m_enodes_per_snode_id[enode->get_supernode ()->m_id].push_back (enode);
   }
 
-  /* Show exploded nodes for BEFORE_SUPERNODE points before N.  */
-  bool add_node_annotations (graphviz_out *gv, const supernode &n,
-			     bool within_table)
+  /* Show exploded nodes for N.  */
+  void add_node_annotations (graphviz_out *gv, const supernode &n)
     const final override
   {
-    if (!within_table)
-      return false;
     gv->begin_tr ();
     pretty_printer *pp = gv->get_pp ();
 
-    gv->begin_td ();
-    pp_string (pp, "BEFORE");
-    pp_printf (pp, " (scc: %i)", m_eg.get_scc_id (n));
-    gv->end_td ();
-
-    unsigned i;
-    exploded_node *enode;
-    bool had_enode = false;
-    FOR_EACH_VEC_ELT (*m_enodes_per_snodes[n.m_index], i, enode)
+    if (m_enodes_per_snode_id[n.m_id].empty ())
+      pp_string (pp, "<TD BGCOLOR=\"red\">UNREACHED</TD>");
+    else
       {
-	gcc_assert (enode->get_supernode () == &n);
-	const program_point &point = enode->get_point ();
-	if (point.get_kind () != PK_BEFORE_SUPERNODE)
-	  continue;
-	print_enode (gv, enode);
-	had_enode = true;
+	/* Adding an empty TD here makes the actual enodes
+	   be right-aligned and tightly packed, greatly
+	   improving the readability of the graph.  */
+	pp_string (pp, "<TD></TD>");
+	for (auto enode : m_enodes_per_snode_id[n.m_id])
+	  {
+	    gcc_assert (enode->get_supernode () == &n);
+	    print_enode (gv, enode);
+	  }
       }
-    if (!had_enode)
-      pp_string (pp, "<TD BGCOLOR=\"red\">UNREACHED</TD>");
+
     pp_flush (pp);
     gv->end_tr ();
-    return true;
   }
 
-  /* Show exploded nodes for STMT.  */
-  void add_stmt_annotations (graphviz_out *gv, const gimple *stmt,
-			     bool within_row)
-    const final override
+  void
+  add_extra_objects (graphviz_out *gv) const final override
   {
-    if (!within_row)
-      return;
     pretty_printer *pp = gv->get_pp ();
 
-    const supernode *snode
-      = m_eg.get_supergraph ().get_supernode_for_stmt (stmt);
-    unsigned i;
-    exploded_node *enode;
-    bool had_td = false;
-    FOR_EACH_VEC_ELT (*m_enodes_per_snodes[snode->m_index], i, enode)
-      {
-	const program_point &point = enode->get_point ();
-	if (point.get_kind () != PK_BEFORE_STMT)
-	  continue;
-	if (point.get_stmt () != stmt)
-	  continue;
-	print_enode (gv, enode);
-	had_td = true;
-      }
+    pp_string (pp, "en_0 [shape=none,margin=0,style=filled,label=<<TABLE><TR>");
+    print_enode (gv, m_eg.m_nodes[0]);
+    pp_string (pp, "</TR></TABLE>>];\n\n");
     pp_flush (pp);
-    if (!had_td)
-      {
-	gv->begin_td ();
-	gv->end_td ();
-      }
-  }
-
-  /* Show exploded nodes for AFTER_SUPERNODE points after N.  */
-  bool add_after_node_annotations (graphviz_out *gv, const supernode &n)
-    const final override
-  {
-    gv->begin_tr ();
-    pretty_printer *pp = gv->get_pp ();
-
-    gv->begin_td ();
-    pp_string (pp, "AFTER");
-    gv->end_td ();
 
     unsigned i;
-    exploded_node *enode;
-    FOR_EACH_VEC_ELT (*m_enodes_per_snodes[n.m_index], i, enode)
+    exploded_edge *eedge;
+    FOR_EACH_VEC_ELT (m_eg.m_edges, i, eedge)
       {
-	gcc_assert (enode->get_supernode () == &n);
-	const program_point &point = enode->get_point ();
-	if (point.get_kind () != PK_AFTER_SUPERNODE)
-	  continue;
-	print_enode (gv, enode);
+	print_enode_port (pp, *eedge->m_src, "s");
+	pp_string (pp, " -> ");
+	print_enode_port (pp, *eedge->m_dest, "n");
+	dot::attr_list attrs;
+	attrs.add (dot::id ("style"), dot::id ("dotted"));
+	if (eedge->m_custom_info)
+	  {
+	    pretty_printer info_pp;
+	    pp_format_decoder (&info_pp) = default_tree_printer;
+	    eedge->m_custom_info->print (&info_pp);
+	    attrs.add (dot::id ("label"),
+		       dot::id (pp_formatted_text (&info_pp)));
+	  }
+	dot::writer w (*pp);
+	attrs.print (w);
+	pp_newline (pp);
       }
-    pp_flush (pp);
-    gv->end_tr ();
-    return true;
   }
 
 private:
+  void
+  print_enode_port (pretty_printer *pp,
+		    const exploded_node &enode,
+		    const char *compass_pt) const
+  {
+    if (const supernode *snode = enode.get_supernode ())
+      pp_printf (pp, "node_%i:en_%i:%s",
+		 snode->m_id, enode.m_index, compass_pt);
+    else
+      pp_printf (pp, "en_%i:%s",
+		 enode.m_index, compass_pt);
+  }
+
   /* Concisely print a TD element for ENODE, showing the index, status,
      and any saved_diagnostics at the enode.  Colorize it to show sm-state.
 
@@ -6367,7 +5049,7 @@ private:
     pretty_printer *pp = gv->get_pp ();
     pp_printf (pp, "<TD BGCOLOR=\"%s\">",
 	       enode->get_dot_fillcolor ());
-    pp_printf (pp, "<TABLE BORDER=\"0\">");
+    pp_printf (pp, "<TABLE BORDER=\"0\" PORT=\"en_%i\">", enode->m_index);
     gv->begin_trtd ();
     pp_printf (pp, "EN: %i", enode->m_index);
     switch (enode->get_status ())
@@ -6433,10 +5115,6 @@ private:
 	p->m_eedge.m_sedge->dump (pp);
 	pp_write_text_as_html_like_dot_to_stream (pp);
 	gv->end_tdtr ();
-	gv->begin_trtd ();
-	pp_gimple_stmt_1 (pp, p->m_last_stmt, 0, (dump_flags_t)0);
-	pp_write_text_as_html_like_dot_to_stream (pp);
-	gv->end_tdtr ();
 	/* Ideally we'd print p->m_model here; see the notes above about
 	   tooltips.  */
       }
@@ -6445,7 +5123,7 @@ private:
   }
 
   const exploded_graph &m_eg;
-  auto_delete_vec<auto_vec <exploded_node *> > m_enodes_per_snodes;
+  std::vector<std::vector <exploded_node *> > m_enodes_per_snode_id;
 };
 
 /* Implement -fdump-analyzer-json.  */
@@ -6517,6 +5195,29 @@ private:
   logger *m_logger;
 };
 
+static void
+maybe_dump_supergraph (const supergraph &sg, const char *name,
+		       const dot_annotator *annotator = nullptr,
+		       const exploded_graph *eg = nullptr)
+{
+  static int dump_idx = 0;
+  if (!flag_dump_analyzer_supergraph)
+    return;
+
+  auto_timevar tv (TV_ANALYZER_DUMP);
+  std::string filename (dump_base_name);
+  filename += ".supergraph.";
+  filename += std::to_string (dump_idx++);
+  filename += ".";
+  filename += name;
+  filename += ".dot";
+  supergraph::dump_args_t args
+    ((enum supergraph_dot_flags)SUPERGRAPH_DOT_SHOW_BBS,
+     annotator,
+     eg);
+  sg.dump_dot (filename.c_str (), args);
+}
+
 /* Run the analysis "engine".  */
 
 void
@@ -6537,32 +5238,38 @@ impl_run_checkers (logger *logger)
   FOR_EACH_FUNCTION_WITH_GIMPLE_BODY (node)
     node->get_untransformed_body ();
 
+  region_model_manager mgr;
+
   /* Create the supergraph.  */
-  supergraph sg (logger);
+  supergraph sg (mgr, logger);
 
-  engine eng (&sg, logger);
+  maybe_dump_supergraph (sg, "original");
 
-  state_purge_map *purge_map = nullptr;
+  sg.fixup_locations (logger);
 
+  maybe_dump_supergraph (sg, "fixup-locations");
+
+  engine eng (mgr, &sg, logger);
+
+  state_purge_map *purge_map = nullptr;
   if (flag_analyzer_state_purge)
     purge_map = new state_purge_map (sg, eng.get_model_manager (), logger);
 
-  if (flag_dump_analyzer_supergraph)
+  if (flag_analyzer_simplify_supergraph)
     {
-      /* Dump supergraph pre-analysis.  */
-      auto_timevar tv (TV_ANALYZER_DUMP);
-      char *filename = concat (dump_base_name, ".supergraph.dot", nullptr);
-      supergraph::dump_args_t args ((enum supergraph_dot_flags)0, nullptr);
-      sg.dump_dot (filename, args);
-      free (filename);
+      sg.simplify (logger);
+      maybe_dump_supergraph (sg, "simplified");
     }
 
+  sg.sort_nodes (logger);
+  maybe_dump_supergraph (sg, "sorted");
+
   if (flag_dump_analyzer_state_purge)
     {
       auto_timevar tv (TV_ANALYZER_DUMP);
       state_purge_annotator a (purge_map);
       char *filename = concat (dump_base_name, ".state-purge.dot", nullptr);
-      supergraph::dump_args_t args ((enum supergraph_dot_flags)0, &a);
+      supergraph::dump_args_t args ((enum supergraph_dot_flags)0, &a, nullptr);
       sg.dump_dot (filename, args);
       free (filename);
     }
@@ -6620,18 +5327,11 @@ impl_run_checkers (logger *logger)
 
   eg.log_stats ();
 
-  if (flag_dump_analyzer_callgraph)
-    dump_callgraph (sg, &eg);
-
   if (flag_dump_analyzer_supergraph)
     {
       /* Dump post-analysis form of supergraph.  */
-      auto_timevar tv (TV_ANALYZER_DUMP);
-      char *filename = concat (dump_base_name, ".supergraph-eg.dot", nullptr);
       exploded_graph_annotator a (eg);
-      supergraph::dump_args_t args ((enum supergraph_dot_flags)0, &a);
-      sg.dump_dot (filename, args);
-      free (filename);
+      maybe_dump_supergraph (sg, "eg", &a, &eg);
     }
 
   if (flag_dump_analyzer_json)
diff --git a/gcc/analyzer/event-loc-info.h b/gcc/analyzer/event-loc-info.h
index bf772eef4ee..9197541bb13 100644
--- a/gcc/analyzer/event-loc-info.h
+++ b/gcc/analyzer/event-loc-info.h
@@ -31,6 +31,9 @@ struct event_loc_info
   : m_loc (loc), m_fndecl (fndecl), m_depth (depth)
   {}
 
+  event_loc_info (const exploded_node *enode);
+  event_loc_info (const program_point &point);
+
   location_t m_loc;
   tree m_fndecl;
   int m_depth;
